function [ X,y,C,x,h,g,z,y1 ] = generate_model_hadamard( m,n1,n2,K )
% m: sample size
% n1: the dimension of signal x
% n2: the dimension of signal h
% K: the number of users
C = cell(K,1);
x = cell(K,1);
h = cell(K,1);
g = cell(K,1);
z = cell(K,1);
X = cell(K,1);
y1 = cell(K,1);
y = zeros(m,1);
F = dftmtx(m)/sqrt(m);
for k=1:K
    h{k} = randn(n2,1)+1i*randn(n2,1);
    h{k} = h{k};%/norm(h{k});
     g{k} = [h{k};zeros(m-n2,1)];
  
    nFFT = n1;
    M = 16;
    modObj = modem.qammod(M);
    XM = randi([0 M-1],nFFT,1);  %BPSK symbols
    XD = modulate(modObj,XM)/sqrt(10); % normalizing symbol power
    xout =(dftmtx(nFFT)/sqrt(nFFT))'*XD;
    D = diag((rand(m,1)<.5)*2 - 1);
    Fc = dftmtx(m)/sqrt(m);
    H = hadamard(m);
    H = H(:,1:n1);
     C{k} = Fc*D*H;
    
    x{k} = xout;
    nFFT = 4;
    M = 4;
    modObj = modem.qammod(M);
    XM = randi([0 M-1],nFFT,1);  %BPSK symbols
    x{k} = modulate(modObj,XM)/sqrt(2); % normalizing symbol power
  
    z{k} = C{k}*x{k};
    X{k} = x{k}*conj(h{k}');
  
    y1{k} = cconv(z{k},g{k},m);
    y = y+F*y1{k}/sqrt(m);   
end
 


end

